#![doc = "This file was automatically generated by the varlink rust generator"]
#![allow(non_camel_case_types)]
#![allow(non_snake_case)]
use serde_derive::{Deserialize, Serialize};
use std::io::BufRead;
use std::sync::{Arc, RwLock};
use varlink::{self, CallTrait};
#[allow(dead_code)]
#[derive(Clone, PartialEq, Debug)]
#[allow(clippy::enum_variant_names)]
pub enum ErrorKind {
    Varlink_Error,
    VarlinkReply_Error,
    BadService(Option<BadService_Args>),
    ConflictingRecordFound(Option<ConflictingRecordFound_Args>),
    EnumerationNotSupported(Option<EnumerationNotSupported_Args>),
    NoRecordFound(Option<NoRecordFound_Args>),
    ServiceNotAvailable(Option<ServiceNotAvailable_Args>),
}
impl ::std::fmt::Display for ErrorKind {
    fn fmt(&self, f: &mut ::std::fmt::Formatter) -> ::std::fmt::Result {
        match self {
            ErrorKind::Varlink_Error => write!(f, "Varlink Error"),
            ErrorKind::VarlinkReply_Error => write!(f, "Varlink error reply"),
            ErrorKind::BadService(v) => write!(f, "io.systemd.UserDatabase.BadService: {:#?}", v),
            ErrorKind::ConflictingRecordFound(v) => write!(
                f,
                "io.systemd.UserDatabase.ConflictingRecordFound: {:#?}",
                v
            ),
            ErrorKind::EnumerationNotSupported(v) => write!(
                f,
                "io.systemd.UserDatabase.EnumerationNotSupported: {:#?}",
                v
            ),
            ErrorKind::NoRecordFound(v) => {
                write!(f, "io.systemd.UserDatabase.NoRecordFound: {:#?}", v)
            },
            ErrorKind::ServiceNotAvailable(v) => {
                write!(f, "io.systemd.UserDatabase.ServiceNotAvailable: {:#?}", v)
            },
        }
    }
}
pub struct Error(
    pub ErrorKind,
    pub Option<Box<dyn std::error::Error + 'static + Send + Sync>>,
    pub Option<&'static str>,
);
impl Error {
    #[allow(dead_code)]
    pub fn kind(&self) -> &ErrorKind {
        &self.0
    }
}
impl From<ErrorKind> for Error {
    fn from(e: ErrorKind) -> Self {
        Error(e, None, None)
    }
}
impl std::error::Error for Error {
    fn source(&self) -> Option<&(dyn std::error::Error + 'static)> {
        self.1
            .as_ref()
            .map(|e| e.as_ref() as &(dyn std::error::Error + 'static))
    }
}
impl std::fmt::Display for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        std::fmt::Display::fmt(&self.0, f)
    }
}
impl std::fmt::Debug for Error {
    fn fmt(&self, f: &mut std::fmt::Formatter) -> std::fmt::Result {
        use std::error::Error as StdError;
        if let Some(ref o) = self.2 {
            std::fmt::Display::fmt(o, f)?;
        }
        std::fmt::Debug::fmt(&self.0, f)?;
        if let Some(e) = self.source() {
            std::fmt::Display::fmt("\nCaused by:\n", f)?;
            std::fmt::Debug::fmt(&e, f)?;
        }
        Ok(())
    }
}
#[allow(dead_code)]
pub type Result<T> = std::result::Result<T, Error>;
impl From<varlink::Error> for Error {
    fn from(e: varlink::Error) -> Self {
        match e.kind() {
            varlink::ErrorKind::VarlinkErrorReply(r) => Error(
                ErrorKind::from(r),
                Some(Box::from(e)),
                Some(concat!(file!(), ":", line!(), ": ")),
            ),
            _ => Error(
                ErrorKind::Varlink_Error,
                Some(Box::from(e)),
                Some(concat!(file!(), ":", line!(), ": ")),
            ),
        }
    }
}
#[allow(dead_code)]
impl Error {
    pub fn source_varlink_kind(&self) -> Option<&varlink::ErrorKind> {
        use std::error::Error as StdError;
        let mut s: &dyn StdError = self;
        while let Some(c) = s.source() {
            let k = self
                .source()
                .and_then(|e| e.downcast_ref::<varlink::Error>())
                .map(|e| e.kind());
            if k.is_some() {
                return k;
            }
            s = c;
        }
        None
    }
}
impl From<&varlink::Reply> for ErrorKind {
    #[allow(unused_variables)]
    fn from(e: &varlink::Reply) -> Self {
        match e {
            varlink::Reply {
                error: Some(ref t), ..
            } if t == "io.systemd.UserDatabase.BadService" => match e {
                varlink::Reply {
                    parameters: Some(p),
                    ..
                } => match serde_json::from_value(p.clone()) {
                    Ok(v) => ErrorKind::BadService(v),
                    Err(_) => ErrorKind::BadService(None),
                },
                _ => ErrorKind::BadService(None),
            },
            varlink::Reply {
                error: Some(ref t), ..
            } if t == "io.systemd.UserDatabase.ConflictingRecordFound" => match e {
                varlink::Reply {
                    parameters: Some(p),
                    ..
                } => match serde_json::from_value(p.clone()) {
                    Ok(v) => ErrorKind::ConflictingRecordFound(v),
                    Err(_) => ErrorKind::ConflictingRecordFound(None),
                },
                _ => ErrorKind::ConflictingRecordFound(None),
            },
            varlink::Reply {
                error: Some(ref t), ..
            } if t == "io.systemd.UserDatabase.EnumerationNotSupported" => match e {
                varlink::Reply {
                    parameters: Some(p),
                    ..
                } => match serde_json::from_value(p.clone()) {
                    Ok(v) => ErrorKind::EnumerationNotSupported(v),
                    Err(_) => ErrorKind::EnumerationNotSupported(None),
                },
                _ => ErrorKind::EnumerationNotSupported(None),
            },
            varlink::Reply {
                error: Some(ref t), ..
            } if t == "io.systemd.UserDatabase.NoRecordFound" => match e {
                varlink::Reply {
                    parameters: Some(p),
                    ..
                } => match serde_json::from_value(p.clone()) {
                    Ok(v) => ErrorKind::NoRecordFound(v),
                    Err(_) => ErrorKind::NoRecordFound(None),
                },
                _ => ErrorKind::NoRecordFound(None),
            },
            varlink::Reply {
                error: Some(ref t), ..
            } if t == "io.systemd.UserDatabase.ServiceNotAvailable" => match e {
                varlink::Reply {
                    parameters: Some(p),
                    ..
                } => match serde_json::from_value(p.clone()) {
                    Ok(v) => ErrorKind::ServiceNotAvailable(v),
                    Err(_) => ErrorKind::ServiceNotAvailable(None),
                },
                _ => ErrorKind::ServiceNotAvailable(None),
            },
            _ => ErrorKind::VarlinkReply_Error,
        }
    }
}
pub trait VarlinkCallError: varlink::CallTrait {
    fn reply_bad_service(&mut self) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "io.systemd.UserDatabase.BadService",
            None,
        ))
    }
    fn reply_conflicting_record_found(&mut self) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "io.systemd.UserDatabase.ConflictingRecordFound",
            None,
        ))
    }
    fn reply_enumeration_not_supported(&mut self) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "io.systemd.UserDatabase.EnumerationNotSupported",
            None,
        ))
    }
    fn reply_no_record_found(&mut self) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "io.systemd.UserDatabase.NoRecordFound",
            None,
        ))
    }
    fn reply_service_not_available(&mut self) -> varlink::Result<()> {
        self.reply_struct(varlink::Reply::error(
            "io.systemd.UserDatabase.ServiceNotAvailable",
            None,
        ))
    }
}
impl<'a> VarlinkCallError for varlink::Call<'a> {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct BadService_Args {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct ConflictingRecordFound_Args {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct EnumerationNotSupported_Args {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct NoRecordFound_Args {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct ServiceNotAvailable_Args {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetGroupRecord_Reply {
    pub r#record: serde_json::Value,
    pub r#incomplete: bool,
}
impl varlink::VarlinkReply for GetGroupRecord_Reply {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetGroupRecord_Args {
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#gid: Option<u32>,
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#groupName: Option<String>,
    pub r#service: String,
}
pub trait Call_GetGroupRecord: VarlinkCallError {
    fn reply(&mut self, r#record: serde_json::Value, r#incomplete: bool) -> varlink::Result<()> {
        self.reply_struct(
            GetGroupRecord_Reply {
                r#record,
                r#incomplete,
            }
            .into(),
        )
    }
}
impl<'a> Call_GetGroupRecord for varlink::Call<'a> {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetMemberships_Reply {
    pub r#userName: String,
    pub r#groupName: String,
}
impl varlink::VarlinkReply for GetMemberships_Reply {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetMemberships_Args {
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#userName: Option<String>,
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#groupName: Option<String>,
    pub r#service: String,
}
pub trait Call_GetMemberships: VarlinkCallError {
    fn reply(&mut self, r#userName: String, r#groupName: String) -> varlink::Result<()> {
        self.reply_struct(
            GetMemberships_Reply {
                r#userName,
                r#groupName,
            }
            .into(),
        )
    }
}
impl<'a> Call_GetMemberships for varlink::Call<'a> {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetUserRecord_Reply {
    pub r#record: serde_json::Value,
    pub r#incomplete: bool,
}
impl varlink::VarlinkReply for GetUserRecord_Reply {}
#[derive(Serialize, Deserialize, Debug, PartialEq, Clone)]
pub struct GetUserRecord_Args {
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#uid: Option<u32>,
    #[serde(skip_serializing_if = "Option::is_none")]
    pub r#userName: Option<String>,
    pub r#service: String,
}
pub trait Call_GetUserRecord: VarlinkCallError {
    fn reply(&mut self, r#record: serde_json::Value, r#incomplete: bool) -> varlink::Result<()> {
        self.reply_struct(
            GetUserRecord_Reply {
                r#record,
                r#incomplete,
            }
            .into(),
        )
    }
}
impl<'a> Call_GetUserRecord for varlink::Call<'a> {}
pub trait VarlinkInterface {
    fn get_group_record(
        &self,
        call: &mut dyn Call_GetGroupRecord,
        r#gid: Option<u32>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::Result<()>;
    fn get_memberships(
        &self,
        call: &mut dyn Call_GetMemberships,
        r#userName: Option<String>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::Result<()>;
    fn get_user_record(
        &self,
        call: &mut dyn Call_GetUserRecord,
        r#uid: Option<u32>,
        r#userName: Option<String>,
        r#service: String,
    ) -> varlink::Result<()>;
    fn call_upgraded(
        &self,
        _call: &mut varlink::Call,
        _bufreader: &mut dyn BufRead,
    ) -> varlink::Result<Vec<u8>> {
        Ok(Vec::new())
    }
}
pub trait VarlinkClientInterface {
    fn get_group_record(
        &mut self,
        r#gid: Option<u32>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetGroupRecord_Args, GetGroupRecord_Reply, Error>;
    fn get_memberships(
        &mut self,
        r#userName: Option<String>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetMemberships_Args, GetMemberships_Reply, Error>;
    fn get_user_record(
        &mut self,
        r#uid: Option<u32>,
        r#userName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetUserRecord_Args, GetUserRecord_Reply, Error>;
}
#[allow(dead_code)]
pub struct VarlinkClient {
    connection: Arc<RwLock<varlink::Connection>>,
}
impl VarlinkClient {
    #[allow(dead_code)]
    pub fn new(connection: Arc<RwLock<varlink::Connection>>) -> Self {
        VarlinkClient { connection }
    }
}
impl VarlinkClientInterface for VarlinkClient {
    fn get_group_record(
        &mut self,
        r#gid: Option<u32>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetGroupRecord_Args, GetGroupRecord_Reply, Error> {
        varlink::MethodCall::<GetGroupRecord_Args, GetGroupRecord_Reply, Error>::new(
            self.connection.clone(),
            "io.systemd.UserDatabase.GetGroupRecord",
            GetGroupRecord_Args {
                r#gid,
                r#groupName,
                r#service,
            },
        )
    }
    fn get_memberships(
        &mut self,
        r#userName: Option<String>,
        r#groupName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetMemberships_Args, GetMemberships_Reply, Error> {
        varlink::MethodCall::<GetMemberships_Args, GetMemberships_Reply, Error>::new(
            self.connection.clone(),
            "io.systemd.UserDatabase.GetMemberships",
            GetMemberships_Args {
                r#userName,
                r#groupName,
                r#service,
            },
        )
    }
    fn get_user_record(
        &mut self,
        r#uid: Option<u32>,
        r#userName: Option<String>,
        r#service: String,
    ) -> varlink::MethodCall<GetUserRecord_Args, GetUserRecord_Reply, Error> {
        varlink::MethodCall::<GetUserRecord_Args, GetUserRecord_Reply, Error>::new(
            self.connection.clone(),
            "io.systemd.UserDatabase.GetUserRecord",
            GetUserRecord_Args {
                r#uid,
                r#userName,
                r#service,
            },
        )
    }
}
#[allow(dead_code)]
pub struct VarlinkInterfaceProxy {
    inner: Box<dyn VarlinkInterface + Send + Sync>,
}
#[allow(dead_code)]
pub fn new(inner: Box<dyn VarlinkInterface + Send + Sync>) -> VarlinkInterfaceProxy {
    VarlinkInterfaceProxy { inner }
}
impl varlink::Interface for VarlinkInterfaceProxy {
    fn get_description(&self) -> &'static str {
        "interface io.systemd.UserDatabase\n\nmethod GetUserRecord(\n        uid : ?int,\n        userName : ?string,\n        service : string\n) -> (\n        record : object,\n        incomplete : bool\n)\n\nmethod GetGroupRecord(\n        gid : ?int,\n        groupName : ?string,\n        service : string\n) -> (\n        record : object,\n        incomplete : bool\n)\n\nmethod GetMemberships(\n        userName : ?string,\n        groupName : ?string,\n        service : string\n) -> (\n        userName : string,\n        groupName : string\n)\n\nerror NoRecordFound()\nerror BadService()\nerror ServiceNotAvailable()\nerror ConflictingRecordFound()\nerror EnumerationNotSupported()\n"
    }
    fn get_name(&self) -> &'static str {
        "io.systemd.UserDatabase"
    }
    fn call_upgraded(
        &self,
        call: &mut varlink::Call,
        bufreader: &mut dyn BufRead,
    ) -> varlink::Result<Vec<u8>> {
        self.inner.call_upgraded(call, bufreader)
    }
    fn call(&self, call: &mut varlink::Call) -> varlink::Result<()> {
        let req = call.request.unwrap();
        match req.method.as_ref() {
            "io.systemd.UserDatabase.GetGroupRecord" => {
                if let Some(args) = req.parameters.clone() {
                    let args: GetGroupRecord_Args = match serde_json::from_value(args) {
                        Ok(v) => v,
                        Err(e) => {
                            let es = format!("{}", e);
                            let _ = call.reply_invalid_parameter(es.clone());
                            return Err(varlink::context!(varlink::ErrorKind::SerdeJsonDe(es)));
                        },
                    };
                    self.inner.get_group_record(
                        call as &mut dyn Call_GetGroupRecord,
                        args.r#gid,
                        args.r#groupName,
                        args.r#service,
                    )
                } else {
                    call.reply_invalid_parameter("parameters".into())
                }
            },
            "io.systemd.UserDatabase.GetMemberships" => {
                if let Some(args) = req.parameters.clone() {
                    let args: GetMemberships_Args = match serde_json::from_value(args) {
                        Ok(v) => v,
                        Err(e) => {
                            let es = format!("{}", e);
                            let _ = call.reply_invalid_parameter(es.clone());
                            return Err(varlink::context!(varlink::ErrorKind::SerdeJsonDe(es)));
                        },
                    };
                    self.inner.get_memberships(
                        call as &mut dyn Call_GetMemberships,
                        args.r#userName,
                        args.r#groupName,
                        args.r#service,
                    )
                } else {
                    call.reply_invalid_parameter("parameters".into())
                }
            },
            "io.systemd.UserDatabase.GetUserRecord" => {
                if let Some(args) = req.parameters.clone() {
                    let args: GetUserRecord_Args = match serde_json::from_value(args) {
                        Ok(v) => v,
                        Err(e) => {
                            let es = format!("{}", e);
                            let _ = call.reply_invalid_parameter(es.clone());
                            return Err(varlink::context!(varlink::ErrorKind::SerdeJsonDe(es)));
                        },
                    };
                    self.inner.get_user_record(
                        call as &mut dyn Call_GetUserRecord,
                        args.r#uid,
                        args.r#userName,
                        args.r#service,
                    )
                } else {
                    call.reply_invalid_parameter("parameters".into())
                }
            },
            m => call.reply_method_not_found(String::from(m)),
        }
    }
}
